# SimpleMacros
SimpleMacros was created to give you a better way of interacting with mods that can only be controlled through console commands.

## Features
* Define your favorite commands in the config file and trigger them using:
	* In-game GUI that displays buttons for all commands defined in the config file
	* Keyboard shortcuts
* Run your commands multiple times, for example a macro for `give_item` (from RoR2Cheats) can be run 50 times to give you 50 items at once.

## Usage
* Install **SimpleMacros** by placing it in the `BepInEx\plugins` directory, or use your favorite mod manager
* Run the game, this will create the configuration file
* Open the following file in a text editor: `BepInEx\config\local.recursiveGecko.ror2.SimpleMacros.cfg`
* Add your commands, following the syntax described below
* Click `Reload config` or restart the game

### Configuration file syntax

The configuration file can contain any number of macros, each one defined like this:
```
[Name of your macro]
command=console command that you want to run
shortcut=F3
repeat=20 
```

Name of your macro: Can be almost anything you want, as long as there are no duplicates.

`shortcut`: **Optional**. Name of a valid `KeyCode` available in Unity. You can find a full list here: [https://docs.unity3d.com/ScriptReference/KeyCode.html](https://docs.unity3d.com/ScriptReference/KeyCode.html)

`repeat`: **Optional**. How many times to execute this command when the macro is triggered.

Since both of these properties are optional, you don't have to define them. A macro without `shortcut` and `repeat` options will still be available as a button in the in-game GUI.

There is also a an option that allows you to set a shortcut to toggle the visibility of the in-game menu:
`toggle_menu_shortcut=F11`

## Planned features
* In-game macro customization

## Bug reports & Feature requests
Please create an issue [here](https://github.com/recursiveGecko/RoR2_Mods/issues). 
If you're reporting a bug, make sure to describe what happened, include your configuration file and any error output relating to SimpleMacros.